# Modifications to gdk-pixbuf to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

# Shared library gdk-pixbuf.
LOCAL_SRC_FILES = io-png.c io-bmp.c io-wbmp.c io-gif.c		\
  io-gif-animation.c io-ico.c io-ani.c io-jpeg.c io-pnm.c	\
  io-ras.c io-tiff.c io-xpm.c io-xbm.c io-tga.c	io-icns.c	\
  io-qtif.c io-pcx.c io-ani-animation.c				\
								\
  gdk-pixbuf.c gdk-pixbuf-animation.c gdk-pixbuf-data.c		\
  gdk-pixbuf-io.c gdk-pixbuf-loader.c gdk-pixbuf-scale.c	\
  gdk-pixbuf-simple-anim.c gdk-pixbuf-scaled-anim.c		\
  gdk-pixbuf-util.c gdk-pixbuf-enum-types.c			\
								\
  pixops/pixops.c

LOCAL_C_INCLUDES := $(LOCAL_PATH) $(LOCAL_PATH)/..		\
  $(LOCAL_PATH)/pixops
LOCAL_STATIC_LIBRARIES := libpng libgif
LOCAL_SHARED_LIBRARIES := libjpeg libtiff gio glib gobject
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include
LOCAL_LDFLAGS := -Wl,--no-undefined
LOCAL_CFLAGS := -DINCLUDE_ani -DINCLUDE_png	\
  -DINCLUDE_bmp					\
  -DINCLUDE_wbmp				\
  -DINCLUDE_gif					\
  -DINCLUDE_ico					\
  -DINCLUDE_jpeg				\
  -DINCLUDE_pnm					\
  -DINCLUDE_ras					\
  -DINCLUDE_tiff				\
  -DINCLUDE_xpm					\
  -DINCLUDE_xbm					\
  -DINCLUDE_tga					\
  -DINCLUDE_pcx					\
  -DINCLUDE_icns				\
  -DINCLUDE_qtif				\
  -DINCLUDE_png					\
  -DGDK_PIXBUF_ENABLE_BACKEND			\
  -DGDK_PIXBUF_COMPILATION			\
  -Wno-deprecated-declarations
LOCAL_MODULE := gdk-pixbuf
include $(BUILD_SHARED_LIBRARY)

$(call import-module,gio)
$(call import-module,glib)
$(call import-module,libgif)
$(call import-module,libjpeg)
$(call import-module,libpng)
$(call import-module,libtiff)
