# Modifications to Glib to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

# Define shared C compilation flags.

ifneq ($(findstring 64,$(TARGET_ARCH)),)
glib_long_size := 8
else
glib_long_size := 4
endif

glib_COMMON_CFLAGS := -DSIZEOF_LONG=$(glib_long_size) \
  -DHAVE_CONFIG_H -DPCRE_STATIC -O2 -Wno-expansion-to-defined

# Include separate Makefiles for subprojects.
include $(LOCAL_PATH)/glib/Android.mk \
  $(LOCAL_PATH)/gthread/Android.mk    \
  $(LOCAL_PATH)/gobject/Android.mk    \
  $(LOCAL_PATH)/gmodule/Android.mk    \
  $(LOCAL_PATH)/gio/Android.mk

