# Modifications to Glib to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

# Shared library libgobject.
LOCAL_SRC_FILES :=		\
	gobjectnotifyqueue.c	\
	gatomicarray.c		\
	gbinding.c		\
	gboxed.c		\
	gclosure.c		\
	genums.c		\
	gmarshal.c		\
	gobject.c		\
	gparam.c		\
	gparamspecs.c		\
	gsignal.c		\
	gsourceclosure.c	\
	gtype.c			\
	gtypemodule.c		\
	gtypeplugin.c		\
	gvalue.c		\
	gvaluearray.c		\
	gvaluetransform.c	\
	gvaluetypes.c

LOCAL_CFLAGS := $(glib_COMMON_CFLAGS) -DGOBJECT_COMPILATION \
  -DG_LOG_DOMAIN=\"GLib-GObject\"
LOCAL_C_INCLUDES := $(LOCAL_PATH) $(LOCAL_PATH)/.. $(LOCAL_PATH)/../glib
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/android-includes
LOCAL_SHARED_LIBRARIES := glib gthread libffi
LOCAL_MODULE := gobject
LOCAL_LDFLAGS = -Wl,--no-undefined

include $(BUILD_SHARED_LIBRARY)
$(call import-module,libffi)
