# Modifications to libcroco to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

# Shared library libcroco.so.

libcroco_0_6_la_SOURCES = \
	cr-utils.c \
	cr-utils.h \
	cr-input.c \
	cr-input.h \
	cr-enc-handler.c \
	cr-enc-handler.h \
	cr-num.c \
	cr-num.h \
	cr-rgb.c \
	cr-rgb.h \
	cr-token.c \
	cr-token.h \
	cr-tknzr.c \
	cr-tknzr.h \
	cr-term.c \
	cr-term.h \
	cr-attr-sel.c \
	cr-attr-sel.h \
	cr-pseudo.c \
	cr-pseudo.h \
	cr-additional-sel.c \
	cr-additional-sel.h \
	cr-simple-sel.c \
	cr-simple-sel.h \
	cr-selector.c \
	cr-selector.h \
	cr-doc-handler.c \
	cr-doc-handler.h \
	cr-parser.c \
	cr-parser.h \
	cr-declaration.c \
	cr-declaration.h \
	cr-statement.c \
	cr-statement.h \
	cr-stylesheet.c \
	cr-stylesheet.h \
	cr-cascade.c \
	cr-cascade.h \
	cr-om-parser.c \
	cr-om-parser.h \
	cr-style.c \
	cr-style.h \
	cr-sel-eng.c \
	cr-sel-eng.h \
	cr-fonts.c \
	cr-fonts.h \
	cr-prop-list.c \
	cr-prop-list.h \
	cr-parsing-location.c \
	cr-parsing-location.h \
	cr-string.c \
	cr-string.h \
	$(NULL)

LOCAL_CFLAGS := -O2 -Wimplicit-function-declaration
LOCAL_C_INCLUDES := $(LOCAL_PATH) $(LOCAL_PATH)/..
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include
LOCAL_SHARED_LIBRARIES := glib libxml2
LOCAL_MODULE := libcroco
LOCAL_LDFLAGS := -Wl,--no-undefined
LOCAL_SRC_FILES := $(filter %.c,$(libcroco_0_6_la_SOURCES))
include $(BUILD_SHARED_LIBRARY)
$(call import-module,libxml2)
$(call import-module,glib)
