# Modifications to libffi to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

ifeq ($(TARGET_ARCH),arm64)
libffi_DIR := $(LOCAL_PATH)/aarch64-pc-linux-android21
else
ifeq ($(TARGET_ARCH),arm)
libffi_DIR := $(LOCAL_PATH)/armv7a-pc-linux-androideabi19
else
ifeq ($(TARGET_ARCH),mips64)
libffi_DIR := $(LOCAL_PATH)/mips64el-pc-linux-android
else
ifeq ($(TARGET_ARCH),mips)
libffi_DIR := $(LOCAL_PATH)/mipsel-pc-linux-android
else
ifeq ($(TARGET_ARCH),x86)
libffi_DIR := $(LOCAL_PATH)/i686-pc-linux-android
else
ifeq ($(TARGET_ARCH),x86_64)
libffi_DIR := $(LOCAL_PATH)/x86_64-pc-linux-android21
endif
endif
endif
endif
endif
endif

include $(libffi_DIR)/Android.mk

