# Modifications to libffi to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

# Shared library libffi.

LOCAL_SRC_FILES := src/prep_cif.c src/types.c src/raw_api.c \
	src/java_raw_api.c src/closures.c src/tramp.c	    \
	src/aarch64/ffi.c src/aarch64/sysv.S
LOCAL_SRC_FILES := $(addprefix ../,$(LOCAL_SRC_FILES))
LOCAL_C_INCLUDES := $(LOCAL_PATH)/include $(LOCAL_PATH)/../include $(LOCAL_PATH)
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include
LOCAL_CFLAGS := -O2 -Wimplicit-function-declaration
LOCAL_LDFLAGS := -Wl,--no-undefined
LOCAL_MODULE := libffi
LOCAL_ASFLAGS := -I$(LOCAL_PATH)/include -I$(LOCAL_PATH)/../include \
  -I$(LOCAL_PATH)
include $(BUILD_SHARED_LIBRARY)
