/* Determine a canonical name for the current locale's character encoding.

   Copyright (C) 2024 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published
   by the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */



#include <locale.h>
#include <string.h>

/* On Android, only two locales are defined, whose charsets are always
   C and UTF-8 respectively.  */

const char *
locale_charset (void)
{
  const char *locale;

  locale = setlocale (LC_CTYPE, NULL);
  return (strcmp (locale, "C") ? "UTF-8" : "ASCII");
}
