# Modifications to libpng to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)
LOCAL_SRC_FILES := png.c pngerror.c\
	pngget.c pngmem.c pngpread.c pngread.c pngrio.c pngrtran.c pngrutil.c\
	pngset.c pngtrans.c pngwio.c pngwrite.c pngwtran.c pngwutil.c
LOCAL_SRC_FILES_x86 := intel/intel_init.c intel/filter_sse2_intrinsics.c
LOCAL_SRC_FILES_x86_64 := intel/intel_init.c intel/filter_sse2_intrinsics.c
LOCAL_CFLAGS_x86 := -DPNG_INTEL_SSE_OPT=1
LOCAL_CFLAGS_x86_64 := -DPNG_INTEL_SSE_OPT=1
LOCAL_CFLAGS_arm64 := -DPNG_ARM_NEON_OPT=2
LOCAL_CFLAGS_arm := -DPNG_ARM_NEON_OPT=0
LOCAL_SRC_FILES_arm64 := arm/arm_init.c\
	arm/filter_neon.S arm/filter_neon_intrinsics.c \
	arm/palette_neon_intrinsics.c
LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
LOCAL_MODULE := libpng
LOCAL_SHARED_LIBRARIES := libz
include $(BUILD_STATIC_LIBRARY)
