# Modifications to libselinux for it to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)
LOCAL_SRC_FILES := src/avc.c \
  src/avc_internal.c \
  src/avc_sidtab.c \
  src/booleans.c \
  src/callbacks.c \
  src/canonicalize_context.c \
  src/checkAccess.c \
  src/check_context.c \
  src/checkreqprot.c \
  src/compute_av.c \
  src/compute_create.c \
  src/compute_member.c \
  src/compute_relabel.c \
  src/compute_user.c \
  src/context.c \
  src/deny_unknown.c \
  src/disable.c \
  src/enabled.c \
  src/fgetfilecon.c \
  src/freecon.c \
  src/freeconary.c \
  src/fsetfilecon.c \
  src/get_context_list.c \
  src/get_default_type.c \
  src/get_initial_context.c \
  src/getdelim.c \
  src/getenforce.c \
  src/getfilecon.c \
  src/getline.c \
  src/getpeercon.c \
  src/hashtab.c \
  src/init.c \
  src/is_customizable_type.c \
  src/label_backends_android.c \
  src/label.c \
  src/label_db.c \
  src/label_file.c \
  src/label_media.c \
  src/label_support.c \
  src/label_x.c \
  src/lgetfilecon.c \
  src/load_policy.c \
  src/lsetfilecon.c \
  src/mapping.c \
  src/matchmediacon.c \
  src/matchpathcon.c \
  src/policyvers.c \
  src/procattr.c \
  src/query_user_context.c \
  src/regex.c \
  src/reject_unknown.c \
  src/selinux_check_securetty_context.c \
  src/selinux_config.c \
  src/selinux_internal.c \
  src/selinux_restorecon.c \
  src/sestatus.c \
  src/setenforce.c \
  src/setexecfilecon.c \
  src/setfilecon.c \
  src/setrans_client.c \
  src/seusers.c \
  src/sha1.c \
  src/stpcpy.c \
  src/stringrep.c \
  src/strvercmp.c \
  src/validatetrans.c

LOCAL_CFLAGS := -DANDROID
LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
LOCAL_C_INCLUDES := $(LOCAL_PATH)/include $(LOCAL_PATH)/src
LOCAL_MODULE := libselinux
LOCAL_SHARED_LIBRARIES := libpcre
LOCAL_LDFLAGS := -Wl,--version-script=$(LOCAL_PATH)/src/libselinux-android.map
include $(BUILD_SHARED_LIBRARY)

# Import required libpcre.
$(call import-module,libpcre)
