# Modifications to GNOME libxml2 to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

libxml2_la_SOURCES = buf.c chvalid.c dict.c entities.c encoding.c error.c	\
		     globals.c hash.c list.c parser.c parserInternals.c		\
		     SAX2.c threads.c tree.c uri.c valid.c xmlIO.c		\
		     xmlmemory.c xmlstring.c HTMLparser.c HTMLtree.c

libxml2_la_SOURCES += c14n.c
libxml2_la_SOURCES += catalog.c
libxml2_la_SOURCES += debugXML.c
libxml2_la_SOURCES += nanoftp.c
libxml2_la_SOURCES += nanohttp.c
libxml2_la_SOURCES += legacy.c
libxml2_la_SOURCES += SAX.c
libxml2_la_SOURCES += xmlmodule.c
libxml2_la_SOURCES += xmlsave.c
libxml2_la_SOURCES += pattern.c
libxml2_la_SOURCES += xmlreader.c
libxml2_la_SOURCES += xmlregexp.c xmlunicode.c
libxml2_la_SOURCES += relaxng.c xmlschemas.c xmlschemastypes.c
libxml2_la_SOURCES += xpath.c
libxml2_la_SOURCES += schematron.c
libxml2_la_SOURCES += xmlwriter.c
libxml2_la_SOURCES += xinclude.c
libxml2_la_SOURCES += xlink.c xpointer.c
libxml2_la_SOURCES += xzlib.c

# Shared library.

include $(CLEAR_VARS)
LOCAL_SRC_FILES		 = $(libxml2_la_SOURCES)
LOCAL_CFLAGS		:= -DHAVE_CONFIG_H -O2 -std=gnu89
LOCAL_C_INCLUDES	:= $(LOCAL_PATH) $(LOCAL_PATH)/include
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include
LOCAL_SHARED_LIBRARIES	:= libz
LOCAL_MODULE		:= libxml2

include $(BUILD_SHARED_LIBRARY)
