# Modifications to Pixman to build on Android.
# Copyright (C) 2024 Free Software Foundation, Inc.

# These modifications are part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

# Include the list of all C source files.
include $(LOCAL_PATH)/Makefile.sources

# Establish the size of long on the target architecture.
ifneq ($(findstring 64,$(TARGET_ARCH)),)
pixman_long_size := 8
else
pixman_long_size := 4
endif

# Shared library pixman.
LOCAL_SRC_FILES := $(libpixman_sources)
LOCAL_MODULE    := pixman
LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)
LOCAL_C_INCLUDES := $(LOCAL_PATH) $(LOCAL_PATH)/..
LOCAL_CFLAGS    := -O2 -Wimplicit-function-declaration \
  -DSIZEOF_LONG=$(pixman_long_size) -DHAVE_CONFIG_H
LOCAL_LDFLAGS   := -Wl,--no-undefined

include $(BUILD_SHARED_LIBRARY)
